#include <map>
#include <sstream>
#include <string>

struct HTTPresponse // for throwing
{
    HTTPresponse(int cde, const std::string& ctype,
                          const std::string& msg)
        : code(cde),contenttype(ctype),content(msg),extraheaders()
    {
    }
    void AddHeader(const std::string& hdr, const std::string& value)
        { extraheaders[hdr]=value; }
    
    int code;
    std::string contenttype;
    std::string content;
    std::map<std::string, std::string> extraheaders;
    
    void Compress_Gzip()
    {
        //std::vector<unsigned char> result(content.size()
        
        // TODO
        // gzencode, 1
        //AddHeader("Content-Encoding", "gzip");
        //AddHeader("Vary",       "Accept-Encoding");
    }
    void Compress_Deflate()
    {
        // TODO
        // gzcompress 
        //AddHeader("Content-Encoding", "deflate");
        //AddHeader("Vary",       "Accept-Encoding");
    }
    
    const std::string ConvertToResponse() const
    {
        std::string resptype = "RESPONSE";
        switch(code)
        {
            case 200: resptype = "OK"; break;
            case 301:
            case 302: resptype = "ALMOST RIGHT"; break;
            case 400: resptype = "BAD REQUEST"; break;
            case 404: resptype = "NOT FOUND"; break;
            case 408: resptype = "CLUMSY FINGERS"; break;
            case 500: resptype = "OH THE PAIN"; break;
        }
        
        std::stringstream resptext;
        resptext << "HTTP/1.1 " << code << " " << resptype << "\r\n"
                    "Content-type: " << contenttype << "\r\n"
                    "Content-length: " << content.size() << "\r\n";
        for(std::map<std::string, std::string>::const_iterator
            i = extraheaders.begin();
            i != extraheaders.end();
            ++i)
        {
            resptext << i->first << ": " << i->second << "\r\n";
        }
        resptext << "\r\n" << content;
        return resptext.str();
    }
};
